#ifndef neo_ports_ComponentFactory_hh_seen
#define neo_ports_ComponentFactory_hh_seen
namespace neo {
namespace cca {
namespace ports {


//===================================================================
//===================================================================

/**NOT YET DEFINED IN CCA.SIDL:
 * This is related to, but not the same as, cca ComponentRepository
 */ 
class ComponentFactory : public virtual neo::cca::Port
{
public:
	
  virtual ~ComponentFactory() {}

  /** Names of classes for which the associated factory can make instances.
   * The 'associated factory' is only accessible through BuilderService
   * createInstance().
   */
  virtual std::vector< std::string> getComponentClassAliases()= 0;

  /** Descriptions of classes we know about.
   */
  virtual std::vector< ComponentClassDescription_shared > getAvailableComponentClasses()= 0;

  virtual neo::cca::Component * createComponentInstance(const std::string & classAlias)= 0;

  virtual neo::cca::Component * createComponentInstance(const std::string & classAlias, neo::cca::TypeMap_shared & properties)= 0;

  virtual void destroyComponentInstance(const std::string & componentClassAlias, neo::cca::Component * component)= 0;

}; // end class ComponentFactory


}  // end namespace ports
}  // end namespace cca
}  // end namespace neo

#endif // neo_ports_ComponentFactory_hh_seen
