#ifndef ComponentRepository_hh_seen
#define ComponentRepository_hh_seen
namespace neo {
namespace cca {
namespace ports {


//===================================================================
//===================================================================

/**NOT YET DEFINED IN CCA.SIDL:
 * This is related to, but not the same as, cca ComponentRepository.  
 */ 
class ComponentRepository : public virtual neo::cca::Port
{
public:
	
  virtual ~ComponentRepository() {}

  /** Names of classes for which the associated factory can make instances.
   * The 'associated factory' is only accessible through BuilderService.
   */
  virtual std::vector< std::string> getComponentClassAliases()= 0;

  /** Descriptions of classes we know about.
   */
  virtual std::vector< ComponentClassDescription_shared > getAvailableComponentClasses()= 0;

}; // end class ComponentRepository


}  // end namespace ports
}  // end namespace cca
}  // end namespace neo

#endif // ComponentRepository_hh_seen
