#ifndef __neoConnectionEventService_H__
#define __neoConnectionEventService_H__

namespace neo {
namespace cca {
namespace ports {

/** "neo.cca.ports.ConnectionEventService": a
 * Port to register/unregister our ConnectionEvent listener interface(s).
 */
class ConnectionEventService : public virtual neo::cca::Port {
private:
public:
	
  /** obligatory vdtor */
  virtual ~ConnectionEventService() {}

  /** Register l as interested in notification of type et.
   * Memory lifecycle:
   * The framework is not responsible for deleting the given
   * object l. The pointer l must be valid until after
   * removeConnectionEventListener returns successfully.
   */
  virtual void addConnectionEventListener(EventType et, ConnectionEventListener * l)= 0;

  /** Remove l as interested in notification of type et.
   * Memory lifecycle:
   * The framework is not responsible for deleting the given
   * object l. The pointer l must be valid until after
   * removeConnectionEventListener returns successfully.
   */
  virtual void removeConnectionEventListener(EventType et, ConnectionEventListener* l)= 0;

};

}  // end namespace ports
}  // end namespace cca
}  // end namespace neo

#endif // __neoConnectionEventService_H__
