#ifndef __neoGOPORT_H__
#define __neoGOPORT_H__

namespace neo {
namespace cca {
namespace ports {

/** "neo.cca.ports.GoPort": A just-do-it port. 
 * Tremendously useful. 
 */
class GoPort : public virtual neo::cca::Port {

public:

	
  /** obligatory vdtor */
  virtual ~GoPort(){}

  /** Make the component do its thing. 
   *  The component does not throw c++ exceptions except in the
   *  form of returning -2.
   * @return
   * <ul><li> 0 if did ok</li>
   * <li>-1 if had problem,</li><li> -2 if had problem bad enough to shoot
   *  the component in the head or exit the framework.</li> 
   * </ul>
  */
  virtual int go()= 0;
};


}  // end namespace ports
}  // end namespace cca
}  // end namespace neo


#endif //__neoGOPORT_H__
