#ifndef neo_ParameterSetListener_h_seen
#define neo_ParameterSetListener_h_seen
namespace neo {
namespace cca {
namespace ports {


/** This interface is typically implemented by a 
  * component using the ParameterPortFactory in a very dynamic
  * fashion.
  */
class ParameterSetListener {
public:
	
  virtual ~ParameterSetListener() {}

  /** The component wishing to be told after a parameter is changed
   * implements this function.
   * @param portName the name of the port (typemap) on which the
   * value was set.
   * @param fieldName the name of the value in the typemap.
   */
  virtual void updatedParameterValue(std::string portName, std::string fieldName)= 0;

}; // end interface ParameterSetListener

}  // end namespace ports
}  // end namespace cca
}  // end namespace neo
#endif // neo_ParameterSetListener_h_seen
